<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

// Component Helper
jimport('joomla.application.component.helper');

class ZoomHelperRoute
{

	function getGalleryRoute($catid) {
		$needles = array(
			'gallery' => array('catid', (int) $catid)
		);

		$catid = JFilterOutput::stringURLSafe(str_replace(':','-',$catid));

		//Create the link
		$link = 'index.php?option=com_zoom&view=gallery&catid='.$catid;

		if ($item = ZoomHelperRoute::_findItem($needles)) {
			 $link .= '&Itemid='.$item->id;
		}
		if (is_object($item) && isset($item->query['layout'])) {
			$link .= '&layout='.$item->query['layout'];
		}

		return $link;
	}

	function getLightboxRoute($catid) {
		$needles = array(
			'lightbox' => ''
		);

		$catid = JFilterOutput::stringURLSafe(str_replace(':','-',$catid));

		//Create the link
		$link = 'index.php?option=com_zoom&view=lightbox'. ($catid? '&catid='.$catid : '');

		if ($item = ZoomHelperRoute::_findItem($needles)) {
			 $link .= '&Itemid='.$item->id;
		}
		if (is_object($item) && isset($item->query['layout'])) {
			$link .= '&layout='.$item->query['layout'];
		}

		return $link;
	}

	function getMediaRoute( $key, $catid ) {

		$needles = array(
			'media' => array('key', (int) $key),
			'gallery' => array( 'catid', (int) $catid),
		);

		$catid = JFilterOutput::stringURLSafe(str_replace(':','-',$catid));
		$key = JFilterOutput::stringURLSafe(str_replace(':','-',$key));

		//Create the link
		$link = 'index.php?option=com_zoom&view=media&catid='.$catid.'&key='.$key;

		if($item = ZoomHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		} else {
			global $Itemid;
			$menus  = &JApplication::getMenu('site', array());
			$item  = $menus->getItem($Itemid);

		}
		if(is_object($item) && $item->query['view'] == 'gallery' && isset($item->query['layout'])) {
			$link .= '&layout='.$item->query['layout'];
		}

		return $link;
	}

	
	function getSpecialRoute( $sorting ) {

		$needles = array(
			'special' => array('sorting', (int) $sorting)
		);

		//Create the link
		$link = 'index.php?option=com_zoom&view=special&sorting='.$sorting;

		if($item = ZoomHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		}

		return $link;
	}

	/**
	* Returns the route to a specific media file
	* @param string $key  The id/slug of the media
	* @param string $catid The id/slug of the gallery
	* @param int $type Specifies whenever to show the thumb, viewsize or the original file (0: viewsize, 1: original, 2: thumb)
	* @param bool $crop Specifies whenever to crop the thumb
	*/
	function getFileRoute( $key, $catid, $type, $crop=false ) {

		$needles = array (
			'media' => array('key', (int) $key),
			'gallery' => array( 'catid', (int) $catid),
		);

		//Create the link
		$catid = JFilterOutput::stringURLSafe(str_replace(':','-',$catid));
		$key = JFilterOutput::stringURLSafe(str_replace(':','-',$key));

		$link = JURI::root() . 'index.php?option=com_zoom&amp;view=media&amp;task=download&amp;catid='.$catid.'&amp;key='.$key.'&amp;type='.$type.($crop?'&amp;crop=1':'');
		return $link;
	}

	function _findItem($needles)
	{
		$component =& JComponentHelper::getComponent('com_zoom');

		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);

		if (!$items) {
			return null;
		}

		$match = null;

		foreach($needles as $needle => $pair)
		{
			foreach($items as $item)
			{
				if ((@$item->query['view'] == $needle) && (!$pair || @$item->query[$pair[0]] == $pair[1])) {
					$match = $item;
					break;
				}
			}

			if(isset($match)) {
				break;
			}
		}

		if (!$match) {
			$match = $items[0];
		}

		return $match;
	}
}
