<?php
//zOOm Media Gallery//
/** 
-----------------------------------------------------------------------
|  zOOm Media Gallery! by Mike de Boer - a multi-gallery component	|
-----------------------------------------------------------------------

-----------------------------------------------------------------------
|														|
| Author: Mike de Boer, <http://www.mikedeboer.nl>				|
| Copyright: copyright (C) 2007 by Mike de Boer				   |
| Description: zOOm Media Gallery, a multi-gallery component for	 |
|			Joomla!. It's the most feature-rich gallery component  |
|			for Joomla!! For documentation and a detailed list	|
|			of features, check the zOOm homepage:			   |
|			http://www.zoomfactory.org						|
| License: GPL											 |
| Filename: image.class.php								   |
|														|
-----------------------------------------------------------------------
* @version $Id: image.class.php 143 2007-03-12 23:49:03Z spignataro $
* @package zOOmGallery
* @author Mike de Boer <mailme@mikedeboer.nl> 
**/
// MOS Intruder Alerts
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * Gallery class; creates an instance of a medium.
 *
 * @access public
 */
class image extends gallery {
	/**
	 * @var int
	 * @access private
	 */
	var $_id = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_name = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_keywords = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_filename = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_descr = null;
	/**
	 * @var datetime
	 * @access private
	 */
	var $_date = null;
	/**
	 * @var int
	 * @access private
	 */
	var $_hits = null;
	/**
	 * @var int
	 * @access private
	 */
	var $_votenum = null;
	/**
	 * @var int
	 * @access private
	 */
	var $_votesum = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_type = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_mimetype = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_thumbnail = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_thumbtype = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_viewsize = null;
	/**
	* @var boolean
	* @access private
	*/
	var $_isBroken = null;
	/**
	 * @var int
	 * @access private
	 */
	var $_published = null;
	/**
	 * @var int
	 * @access private
	 */
	var $_catid = null;
	/**
	 * @var int
	 * @access private
	 */
	var $_uid = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_sql = null;
	/**
	 * @var object
	 * @access private
	 */
	var $_result = null;
	/**
	 * @var array
	 * @access private
	 */
	var $_size = array();
	/**
	 * @var string
	 * @access private
	 */
	/**
	 * @var array
	 * @access private
	 */
	var $_viewsize_size = array();
	/**
	 * @var array
	 * @access private
	 */
	var $_thumb_size = array();
	/**
	 * @var array
	 * @access private
	 */
	var $_comments = array();
	/**
	 * @var array
	 * @access private
	 */
	var $_members = array();
	/**
	 * @var int
	 * @access private
	 */
	var $_custom_order = array();
	/**
	 * @var array
	 * @access private
	 */
	var $_metadata = null;
	/**
	 * @var string
	 * @access private
	 */
	var $_slug = '';

	/**
	 * @var boolean
	 * @access private
	 */
	var $_loaded = false;

	/**
	 * Image object contructor.
	 *
	 * @param int $image_id
	 * @return image
	 * @access public
	 */
	function image($image_id){
		$this->_id = intval($image_id);
		$this->_isBroken = false;
		$this->_loaded = false;
	}
	/**
	 * Retrieves data from the 'mos_zoomfiles' table and assigns it to
	 * the class variables...
	 *
	 * @param boolean $galleryview
	 * @return void
	 * @access public
	 */
	function getInfo($galleryview = true,$forceReload=false) {
		if ( !$this->_loaded || $forceReload ) {
			$database = & JFactory::getDBO();

			$database->setQuery("SELECT imgid, imgname, imgkeywords, imgfilename, imgdescr, date_format(imgdate, '%Y-%m-%d %H:%i:%s') AS date, imghits, votenum, votesum, published, catid, uid, imgmembers,custom_order FROM #__zoomfiles WHERE imgid=".$this->_id);
			$this->_result = $database->query();
			$row= $database->loadObject();
			$this->bind($row);
			$this->getComments();
			// get comments of image...
		}

		if (! $galleryview ) {
			$this->getMetaData();
		}

		$this->_loaded = true;
	}

	function bind( &$row) {
		global   $zoom;

		$this->_id = intval($row->imgid);
		$this->_name = stripslashes($row->imgname);
		$this->_keywords = stripslashes($row->imgkeywords);
		$this->_filename = $row->imgfilename;
		$this->_descr = stripslashes($row->imgdescr);
		$this->_date = $row->date;
		$this->_hits = $row->imghits;
		$this->_votenum = $row->votenum;
		$this->_votesum = $row->votesum;
		$this->_published = $row->published;
		$this->_catid = $row->catid;
		$this->_uid = $row->uid;
		$this->_members = explode(",", $row->imgmembers);
		$this->_custom_order = $row->custom_order;
		$this->_slug = $this->_id . ':'. $this->_name;
		// gallery-members of type 1 are of access-level 'public'
		// and members of type 2 are 'registered'.
		//$this->_members = $members;
		$this->_type = preg_replace("/.*\.([^\.]*)$/", '$1', $this->_filename);
		$this->_type = strtolower($this->_type);
	   	// check if this image is not broken (deleted/ symlink gone...)
	   	if (!$zoom->platform->file_exists(JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS.$this->_filename)) {
	   		$this->_isBroken = true;
		 	$this->_size = array(48, 48);
	   	} else {
	   		$this->_isBroken = false;
	   	}
		$this->setThumbnail();
		$this->_viewsize = $this->getViewsize();
	}

	/**
	 * Change the data entries of a medium.
	 *
	 * @param string $filename
	 * @param string $name
	 * @param string $keywords
	 * @param string $descr
	 * @param int $catid
	 * @param int $uid
	 * @param int $published
	 * @param array $selections
	 * @param int $order
	 * @return boolean
	 * @access public
	 */
	function setImgInfo($filename="", $name, $keywords, $descr, $catid=0, $uid=0, $published=0, $selections=1,$order=NULL) {
		global $zoom;
		if (!isset($this->_filename) && $filename != "") {
			$this->_filename = $filename;
			$this->_type = preg_replace("/.*\.([^\.]*)$/", '$1', $this->_filename);
			$this->_type = strtolower($this->_type);
		}
		$this->_name = str_replace("'", '&#39;', $zoom->htmlnumericentities($name));
		$this->_keywords = str_replace("'", '&#39;', $zoom->htmlnumericentities($keywords));
		$this->_descr = $descr;
		if ($order) {
			$this->_custom_order = $order;
		}
		if (!isset($this->_catid) && $catid != 0) {
			$this->_catid = $catid;
		}
		if (!isset($this->_uid) && $uid != 0) {
			$this->_uid = $uid;
		}
		if (!$this->_published && $published == 1) {
			$this->_published = 1;
		} elseif ($this->_published && $published == 0) {
			$this->_published = 0;
		}
		$this->_members = $selections;
	}
	/**
	 * Save a new medium to the database.
	 *
	 * @return boolean
	 * @access public
	 */
	function save() {
		$database = & JFactory::getDBO();
		$uid = $this->currUID;
		$database->setQuery("INSERT INTO #__zoomfiles (imgfilename, imgname, imgkeywords, imgdescr, imgdate, catid, uid, imgmembers)"
		 . " VALUES "
		 . "('".zoom::escapeString($this->_filename)."', '".zoom::escapeString($this->_name)."', '".zoom::escapeString($this->_keywords)."','".zoom::escapeString($this->_descr)."', NOW(), '".zoom::escapeString($this->_catid)."', '".$this->_uid."', '1')");
		if ($database->query()) {
			$this->_id = $database->insertid();
			return true;
		} else {
			return false;
		}
	}
	/**
	 * Update a medium to the database with newly set variables.
	 *
	 * @param boolean $catimg
	 * @param boolean $parentimg
	 * @return boolean
	 * @access public
	*/
	function update($catimg=0, $parentimg=0) {
		global  $zoom;
		$database = & JFactory::getDBO();

		if (isset($catimg) && $catimg == 1){
			// set new category image, override old one (if it ever existed)...
			$database->setQuery("UPDATE #__zoom SET catimg = ".$this->_id." WHERE catid=".$zoom->_gallery->_id);
			$database->query();
		}else{
			// unset category image, old setting also overridden...
			$database->setQuery("UPDATE #__zoom SET catimg = NULL WHERE catid=".$zoom->_gallery->_id." AND catimg=".$this->_id);
			$database->query();
		}
		if (isset($parentimg) && $parentimg == 1){
			// set new category image for parent-gallery, override old one (if it ever existed)...
			$database->setQuery("UPDATE #__zoom SET catimg = ".$this->_id." WHERE catid=".$zoom->_gallery->_subcat_id);
			$database->query();
		}else{
			// unset category image of parent gallery, old setting also overridden...
			$database->setQuery("UPDATE #__zoom SET catimg = NULL WHERE catid=".$zoom->_gallery->_subcat_id." AND catimg=".$this->_id);
			$database->query();
		}
		// replace space-character with 'air'...or nothing!
		$this->_keywords = str_replace(" ", "", $this->_keywords);
		$database->setQuery("UPDATE #__zoomfiles SET imgname = '".$zoom->escapeString($this->_name)."', imgkeywords='".$zoom->escapeString($this->_keywords)."', imgdescr = '".$zoom->escapeString($this->_descr)."', published = '".$zoom->escapeString($this->_published)."', imgmembers = '".$this->_members."' WHERE imgid=".$this->_id);
		if ($database->query()) {
			return true;
		} else {
			return false;
		}
	}
	/**
	 * Delete an image from the filesystem and the database.
	 *
	 * @return boolean
	 * @access public
	 */
	function delete() {
		global   $zoom;

		$database = & JFactory::getDBO();

		$error = false;
		if (trim($this->_filename)) {
			$file1 = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS.$this->_filename;
			if($zoom->isMovie($this->_type))
				$filename2 = preg_replace("/(.*)\.([^\.]*)$/", '$1', $this->_filename).".jpg";
			else
				$filename2 = $this->_filename;
	
			$file2 = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS."thumbs".DS.$filename2;
			$file3 = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS."viewsize".DS.$this->_filename;
			if($zoom->platform->file_exists($file1) && is_file($file1)){
				if(!@$zoom->platform->unlink($file1)){
					$error = true;				
				}
			}
			//If image is deleted, delete thumb (if it exists at all)
			if (!$error) {
				if ($zoom->isImage($this->_type) || $zoom->isMovie($this->_type)) {
					if ($zoom->platform->file_exists($file2) && is_file($file1)) {// NB: Documents and audiofiles don't have thumbmnails...
						if(!@$zoom->platform->unlink($file2)){
							$error = true;						
						}
					}
				}
			}
			//If thumbnail is deleted, delete the viewsize image (if it exists at all)
			if (!$error) {
				if ($zoom->isImage($this->_type)) {// Only images have viewsize versions of themselves...
					if ($zoom->platform->file_exists($file3) && is_file($file1) ) {
						if (!@$zoom->platform->unlink($file3)) {
							$error = true;
						}
					}
				}
			}
		}

		if (!$error) {
			//Delete record from mos_zoomfiles and comments,ratings and ecards from mos_zoom_comments
			$database->setQuery("DELETE FROM  #__zoomfiles WHERE imgid=".$this->_id);
			$database->query();
			$database->setQuery("DELETE FROM #__zoom_comments WHERE imgid=".$this->_id);
			$database->query();
			$database->setQuery("DELETE FROM #__zoom_rating WHERE imgid=".$this->_id);
			$database->query();
			$database->setQuery("DELETE FROM #__zoom_ecards WHERE imgid=".$this->_id);
			$database->query();
			//Purge the EditMon records
			//Purge the EditMon records
			//Purge the EditMon records
			$zoom->EditMon->purgeComments($this->_id, false);
			// check if the image was a category image...
			$database->setQuery("SELECT catid FROM #__zoom WHERE catimg = ".$this->_id." LIMIT 1");
			$this->_result = $database->query();
			if ( $row =  $database->loadObject() ){
				$database->setQuery("UPDATE #__zoom SET catimg = NULL WHERE catid = ".$row->catid);
				$database->query();
			}
		}
		if ($error) {
			return false;
		} else {
			return true;
		}
	}
	/**
	 * Set the relative path to a thumbnail.
	 *
	 * @return void
	 * @access public
	 */
	function setThumbnail() {
		global   $zoom;
		$live_site = substr_replace(JURI::root(), "", -1, 1);

		if ($this->_isBroken) {
			$this->_thumbnail = $live_site."/components/com_zoom/www/images/filetypes/file_broken.png";
			$this->_thumbtype = "png";
		} else {
			$this->_thumbtype = $this->_type;
		  if ($zoom->isImage($this->_type)) {
			 $this->_thumbnail = $live_site."/".$zoom->_CONFIG['imagepath'].$this->getDir()."/thumbs/".$this->_filename;
		  } elseif($zoom->isDocument($this->_type)) {
			 if ($this->_type == "pdf") {
				$this->_thumbnail = $live_site."/components/com_zoom/www/images/filetypes/pdf.png";
				$this->_thumbtype = "png";
			 } else {
				$this->_thumbnail = $live_site."/components/com_zoom/www/images/filetypes/document.png";
				$this->_thumbtype = "png";
			 }
		  } elseif($zoom->isMovie($this->_type)) {
			 if ($zoom->isThumbnailable($this->_type)) {
				$file = preg_replace("/(.*)\.([^\.]*)$/", '$1', $this->_filename).".jpg";
				if ($zoom->platform->file_exists(JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS."thumbs".DS.$file)) {
					$this->_thumbnail = $live_site."/".$zoom->_CONFIG['imagepath'].$this->getDir()."/thumbs/".$file;
					$this->_thumbtype = "jpg";
				} else {
					$this->_thumbnail = $live_site."/components/com_zoom/www/images/filetypes/video.png";
					$this->_thumbtype = "png";
				}
			 } else {
				$this->_thumbnail = $live_site."/components/com_zoom/www/images/filetypes/video.png";
				$this->_thumbtype = "png";
			 }
		  } elseif($zoom->isAudio($this->_type)) {
			 $this->_thumbnail = $live_site."/components/com_zoom/www/images/filetypes/audio.png";
			 $this->_thumbtype = "png";
		  }
		}
	}

	/**
	 * Get the relative path to a medium viewsize image.
	 *
	 * @return boolean
	 * @access public
	 */
	function getViewsize() {
		global  $zoom;

		$desfile = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS."viewsize".DS.$this->_filename;
		// If the viewsize file doesn't exists, lets try to create it!
		if (!$zoom->platform->file_exists($desfile)) {
			$file = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS.$this->_filename;
			$this->_size = $zoom->platform->getimagesize($file);
			$zoom->toolbox->resizeImage($file, $desfile, $zoom->_CONFIG['maxsize'], $this);
		}
		if ($zoom->platform->file_exists($desfile)) {
			$this->_viewsize_size = $zoom->platform->getimagesize($desfile);
			$this->_viewsize = "viewsize/".$this->_filename;
			return $this->_viewsize;
		} else {
			$this->_viewsize_size = $this->_size;
			$this->_viewsize = $this->_filename;
			return $this->_filename;
		}
	}

	function getThumbSize() {
		global $zoom;

		if ( !$this->_thumb_size ) {
			$desfile=JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS."thumbs".DS.$this->_filename;
			if (!$zoom->platform->file_exists($desfile)) {
				$file = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS.$this->_filename;
				$this->_size = $zoom->platform->getimagesize($file);
				$zoom->toolbox->resizeImage($file, $desfile, $zoom->_CONFIG['size'], $this);
			}
			if ($zoom->platform->file_exists($desfile)) {
				$this->_thumb_size = $zoom->platform->getimagesize($desfile);
			} else {
				$this->_thumb_size = array($zoom->_CONFIG['size'],$zoom->_CONFIG['size']);
			}
		}
		return $this->_thumb_size;
	}

	/**
	 * Get the relative path to a medium viewsize image.
	 *
	 * @return boolean
	 * @access public
	 */
	function getWMImage($type) {
		global  $zoom;

		if ( $type == 'viewsize' ) {
			$srcfile = JPATH_SITE."/".$zoom->_CONFIG['imagepath'].$this->getDir()."/viewsize/".$this->_filename;
			$desfile = JPATH_SITE."/".$zoom->_CONFIG['imagepath'].$this->getDir()."/viewsize/_wm_".$this->_filename;

			// If the  file doesn't exists, lets use the original file
		} else {
			$srcfile = JPATH_SITE."/".$zoom->_CONFIG['imagepath'].$this->getDir()."/".$this->_filename;
			$desfile = JPATH_SITE."/".$zoom->_CONFIG['imagepath'].$this->getDir()."/_wm_".$this->_filename;
		}

		if (!$zoom->platform->file_exists($desfile)) {
			 }

		return $desfile;
	}
	/**
	 * Check if a medium has been resized while it was uploaded.
	 *
	 * @return boolean
	 * @access public
	 */
	function isResized() {
		if (strstr($this->_viewsize, 'viewsize/')) {
			return true;
		} else {
			return false;
		}
	}
	/**
	 * Get the comments a medium contains.
         * TODO: optimize this function. get all comments info in just one query
	 *
	 * @return void
	 * @access public
	 */
	function getComments() {
		$database = & JFactory::getDBO();
		global $zoom;

		$this->_comments = array();
		$database->setQuery(	'SELECT cmtid FROM #__zoom_comments WHERE imgid = '.$this->_id.
						(!$zoom->_isAdmin?' AND cmtapproved=1' : '').
					' ORDER BY cmtdate ASC');
		if ( $rows = $database->loadObjectList() ) {
			foreach ( $rows as $row ) {
				$comment = new comment($row->cmtid);
				$this->_comments[] = $comment;
			}
		}
	}
	/**
	 * Get the metadata (i.e. id3 tag information) of a medium.
	 *
	 * @return void
	 * @access public
	 */
	function getMetaData() {
		global  $zoom;

		if (!$this->_isBroken) {
			$file = JPATH_SITE."/".$zoom->_CONFIG['imagepath'].$this->getDir()."/".$this->_filename;
			if ($zoom->isImage($this->_type)) {
			$this->_size = $zoom->platform->getimagesize($file);
			} elseif (($zoom->isAudio($this->_type) || $zoom->isMovie($this->_type)) && $zoom->_CONFIG['readID3']) {
			$this->_metadata = $zoom->toolbox->getid3($file);
			}
		}
	}

	/**
	 * Update the hit counter of a medium
	 *
	 * @return void
	 * @access public
	 */
	function hitPlus() {
		if (!isset($_SESSION['zmghits'])) {
			$_SESSION['zmghits'] = array();
		}
		if (!isset($_SESSION['zmghits'][$this->_id])) {
			$database = & JFactory::getDBO();
			$database->setQuery("UPDATE #__zoomfiles SET imghits=imghits+1 WHERE imgid=".$this->_id);
			$database->query();
			$this->_hits++;
			$_SESSION['zmghits'][$this->_id] = true;
		}
	}
	
	function canRate() {
		global $zoom;
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();

		$vote_ip = getenv( 'REMOTE_ADDR' );

		# Check if this user has voted before
		if ( $user->get('id') == 0 ) {
			$db->setQuery( "SELECT `ratedate` FROM #__zoom_rating WHERE imgid ='".$this->_id."' AND `ipaddr` = '".$vote_ip."'" );
		} else {
			$db->setQuery( "SELECT `ratedate` FROM #__zoom_rating WHERE imgid ='".$this->_id."' AND `userid` = ".$user->get('id'));
		}
		$ratedate = $db->loadResult();
		$voted = ($ratedate) ? true : false;

		# Allow rating?
		if (
			($voted && $zoom->_CONFIG['rate_once'] == '1')	||
			($zoom->_CONFIG['user_rating'] == 1 && $user->get('id') < 1) ||
			($zoom->_CONFIG['user_rate_own'] == 0 && $user->get('id') == $this->_uid)
		) {
			$allowRating = false;
		} else {
			$allowRating = true;
		}
		return $allowRating;
	}

	/**
	 * Update the votes of a medium with a new vote casted by a user.
	 *
	 * @param int $vote
	 * @return void
	 * @access public
	 */
	function rateImg($vote) {
		global  $zoom;
		$db = & JFactory::getDBO();
		$user = & JFactory::getUser();
		$userid = $user->get('id');
		$ipaddr = getenv( 'REMOTE_ADDR' );

		if (!$zoom->EditMon->isEdited($this->_id, 'vote') && $vote >= 0) {
			$db->setQuery("INSERT INTO #__zoom_rating (imgid,userid,ipaddr,value) VALUES ({$this->_id},{$userid},'{$ipaddr}',{$vote})");
			if ($db->query()) {
				$db->setQuery("UPDATE #__zoomfiles SET votesum=votesum+$vote, votenum=votenum+1 WHERE imgid={$this->_id}");
				$db->query();
				$zoom->EditMon->setEditMon($this->_id, 'vote');
				$this->_votesum = $this->_votesum + $vote;
				$this->_votenum++;
				return true;
			}
		}
		return false;
	}

	/**
	 * Check if this image has already been rated and draw the stars accordingly.
	 *
	 * @return string
	 */
	function getStars($align='left') {
		global $zoom;
		$html = "";
		if (!$zoom->EditMon->isEdited($this->_id, 'vote') && $this->canRate()) {
			$html = $this->_drawVotingStars($this->_votenum, $this->_votesum,$align);
		} else {
		   $html = $this->_drawStars($this->_votenum, $this->_votesum,$align);
		}
		return $html;
	}

	/**
	 * Check if this image has already been rated and draw the stars accordingly.
	 *
	 * @return string
	 */
	function getStaticStars() {
		return $this->_drawStars($this->_votenum, $this->_votesum);
	}

	/**
	 * Draw the stars
	 *
	 * @param int $votes
	 * @param int $points
	 * @return string
	 */
	function _drawStars($votes, $points,$align='left') {
		if ($votes > 0) {
			$rate = $points / $votes;
		} else {
			$rate = 0;
		}
		//$html = '<div class="PSR_container" onmouseout="Zoom.PSR_star_out(this)">';
		$html = '<div id="unit_long'.$this->_id.'" style="text-align:'.$align.';">
		<ul class="unit-rating"' .  ($align == 'center'? ' style="margin:0 auto;"':'') . '>
		<li class="current-rating" style="list-style:none;width:'.(@number_format($rate,2)*15).'px;"><span class="hide">'.@number_format($rate,2).'</span></li>';
		for ($ncount = 1; $ncount <= 5; $ncount++) {
			$html .= '<li class="starli" style="list-style:none;"><span title="'.JText::_('RATE'.$ncount).'" class="r'.$ncount.'-unit"><span class="hide">'.$ncount.'</span></span></li>';
	    }
		$ncount = 0; // resets the count
		$html .= '</ul>
		<strong> '.@number_format($rate, 2).'</strong>/ '.$votes.' '.(($this->_votenum == 1) ? JText::_('VOTE') : JText::_('VOTES')).'
		</div>';
		return $html;
	}

	/**
	 * Draw the voting stars
	 *
	 * @param int $votes
	 * @param int $points
	 * @return string
	 */
	function _drawVotingStars($votes, $points,$align='left') {
		if ($votes > 0) {
			$rate = $points / $votes;
		} else {
			$rate = 0;
		}
		//$html = '<div class="PSR_container" onmouseout="Zoom.PSR_star_out(this)">';
		$html = '<div id="unit_long'.$this->_id.'" style="text-align:'.$align.';">
		<ul class="unit-rating"' .  ($align == 'center'? ' style="margin:0 auto;"':'') . '>
		<li class="current-rating" style="list-style:none;text-align:'.$align.';width:'.(@number_format($rate,2)*15).'px;"><span class="hide">'.@number_format($rate,2).'</span></li>';
		for ($ncount = 1; $ncount <= 5; $ncount++) {
			$html .= '<li class="starli" style="list-style:none;"><a href="javascript:Zoom.unit_save_vote(\''.$this->_id.'\', \''.$ncount.'\')" title="'.JText::_('RATE'.$ncount).'" class="r'.$ncount.'-unit"><span class="hide">'.$ncount.'</span></a></li>';
	    }
		$ncount = 0; // resets the count
		$html .= '</ul>
		<strong> '.@number_format($rate, 2).'</strong>/ '.$votes.' '.(($this->_votenum == 1) ? JText::_('VOTE') : JText::_('VOTES')).'
		</div>';
		return $html;
	}

	/**
	 * Add a comment to the medium.
	 *
	 * @param string $uname
	 * @param string $comment
	 * @return void
	 * @access public
	 */
	function addComment($uname, $comment,$approved) {
		global  $zoom, $mainframe;
		$catid = JRequest::getVar('catid');
		$Itemid = JRequest::getInt('Itemid');
		$database =& JFactory::getDBO();
		$user =& JFactory::getUser();
		
		$uid	= $user->get('id');
		$ipaddr = $database->getEscaped($_SERVER['REMOTE_ADDR']);
		
		$dbcomment = str_replace("'", "&#39;", $comment);
		if (!$zoom->EditMon->isEdited($this->_id, 'comment')) {
			$uname = $zoom->cleanString($uname);
			$dbcomment = $zoom->cleanString($dbcomment);
			if (strlen($comment) > $zoom->_CONFIG['cmtLength']) {
				$dbcomment = substr($dbcomment, 0, $zoom->_CONFIG['cmtLength']-4)."...";
			}
			$database->setQuery("INSERT INTO #__zoom_comments (imgid,cmtname,cmtuid,cmtcontent,cmtdate,cmtapproved,cmtapprovedby,cmtipaddr) VALUES ('{$this->_id}','".$zoom->escapeString($uname)."',$uid,'".$zoom->escapeString($dbcomment)."', NOW(),$approved,0,'$ipaddr')");

			if ($database->query()) {
				$zoom->EditMon->setEditMon($this->_id, 'comment');
				$imglink = JRoute::_(ZoomHelperRoute::getMediaRoute($this->_slug,$catid),false,2);
	
				// Should we notify the owner of the media?
				if ( $zoom->_CONFIG['notify_owner_comments'] ) {
					// Let's prepare the email to the owner of the image
					$subject = JText::_('NEW_COMMENT_SUBJECT_OWNER');
					$body = str_replace('{UNAME}',$uname,JText::_('NEW_COMMENT_BODY_OWNER'));
					$body = str_replace('{COMMENT}',$comment,$body);
					$body = str_replace('{IMGLINK}',$imglink,$body);
					$body = str_replace('{IMGNAME}',$this->_name,$body);
		
					$database->setQuery("SELECT b.email AS email FROM #__zoomfiles a, #__users b WHERE a.imgid=".$this->_id." AND a.uid=b.id");
					$result = $database->loadResult();
					$sentmail = JUTility::sendMail($mainframe->getCfg('mailfrom'), $mainframe->getCfg('fromname'), $result, $subject, $body );
				}
	
				// Should we notify the admin?
				if ( $zoom->_CONFIG['notify_admin_comments'] ) {
					// Let's prepare the email to the owner of the image
					$subject = JText::_('NEW_COMMENT_SUBJECT_ADMIN');
					$body = str_replace('{UNAME}',$uname,JText::_('NEW_COMMENT_BODY_ADMIN'));
					$body = str_replace('{COMMENT}',$comment,$body);
					$body = str_replace('{IMGLINK}',$imglink,$body);
					$body = str_replace('{IMGNAME}',$this->_name,$body);
		
					$database->setQuery("SELECT email AS email FROM #__users b WHERE username='admin'");
					$result = $database->loadResult();
					$sentmail = JUTility::sendMail($mainframe->getCfg('mailfrom'), $mainframe->getCfg('fromname'), $result, $subject, $body );
				}
	
				// reload/refill comments array...
				$this->getComments();
				return true;
			}
		}
		return false;

	}
	/**
	 * Delete a comment
	 *
	 * @param int $delComment
	 * @return void
	 * @access public
	 */
	function delComment($delComment) {
		global  $zoom;
		$database = & JFactory::getDBO();

		$database->setQuery("DELETE FROM #__zoom_comments WHERE cmtid=".intval(zoom::escapeString($delComment)));
		$database->query();
		$zoom->EditMon->purgeComments($this->_id);
		$this->getComments();
	}
	/**
	 * Check if a medium is the gallery-image of its parent gallery.
	 *
	 * @param int $parent_id
	 * @return boolean
	 * @access public
	 */
	function isParentImage($parent_id) {
		$database = & JFactory::getDBO();
		$database->setQuery("SELECT catid FROM #__zoom WHERE catimg=".$this->_id);
		$this->_result = $database->query();
		while ( $cat = $database->loadObject() ) {
			if ($cat->catid == $parent_id) {
				return true;
			}
		}
		return false;
	}
	/**
	 * Check if a medium is published
	 *
	 * @return boolean
	 * @access public
	 */
	function isPublished() {
		if ($this->_published == 1) {
			return true;
		} else {
			return false;
		}
	}
	/**
	* Get the number of comments a medium contains.
	*
	* @return int
	* @access public
	*/
	function getNumOfComments(){
		return count($this->_comments);
	}
	/**
	* Get the directory of the gallery a medium resides in.
	*
	* @return string
	* @access public
	*/
	function getDir(){
		$database = & JFactory::getDBO();
		$database->setQuery("SELECT catdir FROM #__zoom WHERE catid=".$this->_catid);
		$catdir = $database->loadResult();
		return $catdir;
	}
	/**
	* Get the keywords of a medium in a HTML formatted string.
	*
	* @param int $method
	* @return string
	* @access public
	*/
	function getKeywords($method = 1) {
		global $Itemid, $zoom;
		// This function will return the list of keywords in two methods:
		// 1: plain list (comma seperated) of keywords.
		// 2: each keyword as hyperlink to the search-page...a search for
		//	items matching that keyword will be conducted automatically.
		if ($method == 1) {
			return $this->_keywords;
		} elseif ($method == 2) {
			// used for display purposes only (media view)...
			$keywords = explode(", ", $this->_keywords);
			$list = "";
			$counter = 0;
			foreach ($keywords as $keyword) {
				$keyword = trim($keyword);
				if ($keyword) {
					if ($counter != 0) {
						$list .= ", ";
					}
					if ($zoom->_CONFIG['popUpImages']) {
						$list .= "<a href=\"javascript:void(0);\" onclick=\"searchKeyword('".$keyword."')\">".$keyword."</a>";
					} else {
						$keyword_uri = JRoute::_("index.php?option=com_zoom&page=search&type=quicksearch&sstring=".$keyword."&Itemid=".$Itemid."");
						$list .= "<a href=\"".$keyword_uri."\">".$keyword."</a>";
					}
					$counter++;
				}
			}
			return $list;
		}
	}

	/**
	 * Get the username of the user who uploaded a medium
	 *
	 * @param int $method
	 * @return string
	 * @access public
	 */
	function getUsername($method = 1) {
		global  $Itemid, $zoom;
		$database = & JFactory::getDBO();

		$database->setQuery("SELECT username FROM #__users WHERE id = $this->_uid LIMIT 1");
		$user = $database->loadResult();
		
		if (!$user) {
			return '';
		}

		$username = "";
		if ($method == 1) {
			$username = $user;
		} elseif ($method == 2) {
			if ($zoom->_CONFIG['userIntegration'] == 'cb'  && $this->_uid && $cbUser =& CBuser::getInstance( $this->_uid ) ){
				# $cbUser		=&	CBuser::getInstance( $this->_uid );
				#$oValue		=	$cbUser->avatarFilePath( );
				$userData   = $cbUser->getUserData();
				$andItemid 	= getCBprofileItemid( true, false );

				$username = '<a href="'.cbSef("index.php?option=com_comprofiler&amp;task=userProfile&amp;user=".$this->_uid.$andItemid).'" title="'. _UE_SHOW_POFILE_OF . ' ' . $userData->username . '">';
				#if ( $oValue ) {
				#	echo '<img src="' . htmlspecialchars( $oValue ) . '" style="margin: 0px 1px 3px 1px; border-width:0px;" alt="'.$userData->username. '" title="'. _UE_SHOW_POFILE_OF . ' ' . $userData->username . '" class="zmg-avatar" />';
				#}
				$username .= $userData->username;
				$username .= "</a>";
			} else {
				if ($zoom->_CONFIG['popUpImages']) {			
					$username = "<a href=\"javascript:void(0);\" onclick=\"searchKeyword('".$user."')\">".$user."</a>";
				} else {
					$username_uri = JRoute::_("index.php?option=com_zoom&page=search&type=quicksearch&sstring=".$user."&Itemid=".$Itemid."");
					$username = "<a href=\"".$username_uri."\">".$user."</a>";
				}
			}
		}
		return $username;
	}

	/**
	 * Figure out the MIME type of this medium
	 *
	 * @param string $user_path
	 * @return string
	 * @access public
	 */
	function getMimeType($user_type = null, $user_path = null) {
		if (empty($this->_mimetype)) {
			if (empty($user_path)) {
				global  $zoom;
				$user_path = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$this->getDir().DS.$this->_filename;
			}
			//$this->_mimetype = MIME_Type::autoDetect($user_path, $user_type, $this->_type);
			if (!$this->_mimetype | empty($this->_mimetype)) {
				$ext = preg_replace("/.*\.([^\.]*)$/", '$1', $this->_filename);
				$this->_mimetype = MIME_Helper::convertExtensionToMime($ext);
			}
			return $this->_mimetype;
			} else {
				return $this->_mimetype;
			}
	}
	/**
	 * Check if a user may see the a medium.
	 *
	 * @param boolean $popup
	 * @return boolean
	 * @access public
	 */
	function isMember($popup = false) {
		global $zoom;
		$my = & JFactory::getUser();

		if ($zoom->currGID) {
			$registered = true;
		} else {
			$registered = false;
		}
		// Don't forget strict mode looking for $my->id.  It will be 0 for unregistered!
		if (in_array("1", $this->_members) || (in_array("2", $this->_members) && $registered) || in_array($my->id, $this->_members, true) || $zoom->_isAdmin) {
		  return true;
		} else {
			$res = false;
		  foreach ($this->_members as $member) {
			 if (strstr($member, "gid-")) {
				$m_gid = intval(str_replace("gid-", "", $member));
				//echo "DEBUG: ".$zoom->currGID." >= ".$m_gid."<br />";
				if ($zoom->currGID >= $m_gid) {
					$res = true;
				}
			 }
		  }
		  return $res;
		} 
	}
}
