<?php

function ZoomBuildRoute(&$query)
{
	$segments = array();

	$specials = array(
		0 => JText::_('TOPTEN'),
		1 => JText::_('LASTSUBM'),
		2 => JText::_('LASTCOMM'),
		4 => JText::_('TOPRATED')
	);
	
	// get a menu item based on Itemid or currently active
	$menu = &JSite::getMenu();
	if (empty($query['Itemid'])) {
		$menuItem = &$menu->getActive();
	} else {
		$menuItem = &$menu->getItem($query['Itemid']);
	}
	$mView	= (empty($menuItem->query['view'])) ? 'gallery' : $menuItem->query['view'];
	$mCatid	= (empty($menuItem->query['catid'])) ? null : $menuItem->query['catid'];
	$mId	= (empty($menuItem->query['key'])) ? null : $menuItem->query['key'];

	if(isset($query['PageNo']) && $query['PageNo'] <= 1){
		unset($query['PageNo']);
	}

	if(isset($query['view']))
	{
		$view = $query['view'];
		if(empty($query['Itemid'])) {
			$segments[] = $query['view'];
		}
		
		if ($view == 'special' && $view != $mView && isset($query['sorting'])) {
			$segments[] = $view;
			$segments[] = JFilterOutput::stringURLSafe(strtolower($specials[$query['sorting']]));
		}
		unset($query['view']);
	} else {
		$view = 'gallery';
	}

	// are we dealing with a media that is attached to a menu item?
	if (($mView == 'media') and (isset($query['key'])) and ($mId == intval($query['key']))) {
		unset($query['view']);
		unset($query['catid']);
		unset($query['key']);
	}

	if (isset($view) and $view == 'gallery' and !empty($query['key'])) {
		if ($mId != intval($query['key']) || $mView != $view) {
			$segments[] = 'media';
			$segments[] = $query['key'];
		}
		unset($query['key']);
	}

	if ( in_array($view,array('lightbox')) ) {
		$segments[] = $view;
	} elseif (isset($query['catid'])) {
		if ($mView != 'gallery' || $mCatid != $query['catid']) {
			$segments[] = $query['catid'];
		}
		unset($query['catid']);
	};
	
	if ($view == 'special') {
		unset($query['sorting']);
	}

	if(isset($query['key'])) {
		if (empty($query['Itemid'])) {
			$segments[] = 'media';
			$segments[] = $query['key'];
		} else {
			if (isset($menuItem->query['key'])) {
				if($query['key'] != $mId) {
					$segments[] = 'media';
					$segments[] = $query['key'];
				}
			} else {
				$segments[] = 'media';
				$segments[] = $query['key'];
			}
		}
		unset($query['key']);
	};
/*
	if(isset($query['year'])) {

		if(!empty($query['Itemid'])) {
			$segments[] = $query['year'];
			unset($query['year']);
		}
	};

	if(isset($query['month'])) {

		if(!empty($query['Itemid'])) {
			$segments[] = $query['month'];
			unset($query['month']);
		}
	};
*/
	if(isset($query['layout']))
	{
		if(!empty($query['Itemid']) && isset($menuItem->query['layout'])) {
			if ($query['layout'] == $menuItem->query['layout']) {

				unset($query['layout']);
			}
		} else {
			if($query['layout'] == 'default') {
				unset($query['layout']);
			}
		}
	};

	return $segments;
}

function ZoomParseRoute($segments)
{
	$vars = array();

	//Get the active menu item
	$menu =& JSite::getMenu();
	$item =& $menu->getActive();

	// Count route segments
	$count = count($segments);

	$lang =& JFactory::getLanguage();
	$lang->load('com_zoom',JPATH_SITE);

	if ($count>1 && $segments[$count-2] == 'media') {
		$vars['catid'] = $segments[$count-3];
		$vars['key'] = $segments[$count-1];
		$vars['view'] = 'media';
	} elseif ($segments[$count-1] == 'lightbox') {
		$vars['view'] = $segments[$count-1];
	} elseif (isset($segments[$count-2]) && $segments[$count-2] == 'special') {
		$segment = str_replace(':','-',$segments[$count-1]);
		$vars['view'] = 'special';
		JFilterOutput::stringURLSafe(strtolower(JText::_('LASTSUBM')));
		switch ($segment) {
			case JFilterOutput::stringURLSafe(strtolower(JText::_('TOPTEN'))):
				$vars['sorting']  = 0;
				break;
			case JFilterOutput::stringURLSafe(strtolower(JText::_('LASTSUBM'))):
				$vars['sorting']  = 1;
				break;
			case JFilterOutput::stringURLSafe(strtolower(JText::_('LASTCOMM'))):
				$vars['sorting']  = 2;
				break;
			case JFilterOutput::stringURLSafe(strtolower(JText::_('TOPRATED'))):
				$vars['sorting']  = 4;
				break;
		}
	} else {
				$vars['catid']  = $segments[$count-1];
				$vars['view'] = 'gallery';
	}

	return $vars;
}
