<?php

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once (JPATH_COMPONENT.DS.'view.php');

/**
 * HTML Zoom View class for the ZMG component
 *
 * @package             zOOmGallery
 * @subpackage  zOOmGallery
 * @since 1.5
 */
 
class ZoomViewGallery extends ZoomView
{
	function display($tpl = null)
	{
		global $zoom, $mainframe;

		$document	=& JFactory::getDocument();
		$gallery	=& $this->get('Gallery');
		$images		=& $this->get('Images');
		$params		=& $mainframe->getParams('com_zoom');
		$action		= JRequest::getCmd('action');
		$pathway 	=& $mainframe->getPathWay();

		$access			= new stdclass();
		$access->canEdit	= ($zoom->_isAdmin || (($gallery->_id && ($gallery->_uid == $zoom->currUID || $gallery->_shared == 1)) && $zoom->privileges->hasPrivilege('priv_editgal')));
        $access->canCreate	= ($zoom->_isAdmin || $zoom->privileges->hasPrivilege('priv_creategal'));
		$access->canDelete	= ($zoom->_isAdmin || (($gallery->_id && ($gallery->_uid == $zoom->currUID || $gallery->_shared == 1)) && $zoom->privileges->hasPrivilege('priv_delgal')));
		$access->canUpload	= ($zoom->_isAdmin || (($gallery->_id && ($gallery->_uid == $zoom->currUID || $gallery->_shared == 1)) && $zoom->privileges->hasPrivilege('priv_upload')));

		if ( JRequest::getCmd('task') == 'mediarss' ) {
			$this->showMediaRSS($gallery,$images);
			return true;
		}
		
		$params->def('page_size', $zoom->_CONFIG['PageSize']?$zoom->_CONFIG['PageSize'] :9 );
		$params->def('columns_number',  $zoom->_CONFIG['columnsno']);

		if ( !$gallery->_id ) {
			$title = $zoom->_CONFIG['zoom_title'];
		} else {
			$gallery->setCatImg(); 
			$title= $zoom->revnumericentities($gallery->_name);
		}

		$document->setTitle($title);
		$this->assignRef('page_title'   , $title);

		// Piclens and Media RSS support
		if ( $params->get('enable_mediarss',1) ) {
			$mainframe->addCustomHeadTag('<link rel="alternate" href="'.JRoute::_(ZoomHelperRoute::getGalleryRoute($gallery->_slug).'&task=mediarss').'" type="application/rss+xml" title="" id="gallery" />');
			if ($params->get('enable_slideshow',1) ) {
				$mainframe->addCustomHeadTag('<script type="text/javascript" src="http://lite.piclens.com/current/piclens.js"></script>');
			}
		}
		
		// Add the pathway to Joomla
		if ( $gallery->_id > 0 && $gallery->_subcat_id > 0 ) {
			$parent = $gallery->getSubcatName();
			$parentPathWay = array($parent,JRoute::_(ZoomHelperRoute::getGalleryRoute($gallery->_subcat_slug)));
			if ($gallery->_pos >= 2) {
				$pathway->addItem('...','');
			}
			$pathway->addItem($parentPathWay[0],$parentPathWay[1]);
		}
		$pathway->addItem($gallery->_name);
	
		if ($action) {
			switch ($action) {
				case 'edit':
					if ( !$access->canEdit ) {
						JError::raiseError(403, JText::_("ALERTNOTAUTH"));
						exit;
					}
					$this->setLayout('form');
					$this->_editForm($gallery,$tpl);
					break;
				case 'organize':
					if ( !$access->canEdit ) {
						JError::raiseError(403, JText::_("ALERTNOTAUTH"));
						exit;
					}
					$tpl = 'organize';
					$this->_organizeForm($gallery,$tpl);
					break;
				case 'delete':
					if ( !$access->canDelete ) {
						JError::raiseError(403, JText::_("ALERTNOTAUTH"));
						exit;
					}
					$tpl = 'delete';
					$this->_deleteForm($gallery,$tpl);
					break;
				case 'upload':
					if ( !$access->canUpload ) {
						JError::raiseError(403, JText::_("ALERTNOTAUTH"));
						exit;
					}
					$tpl = 'upload';
					$this->_uploadForm($gallery,$tpl);
					break;
			}
			return;
		}

		$galleries	=& $this->get('Subgalleries');

		$val = $params->get('enable_mediarating',-1);
		if ( $val == -1 ) {
			$params->set('enable_mediarating',$zoom->_CONFIG['ratingOn']);
		}

		if ($params->get('enable_mediarating')) {
			$zoom->createRatingCSS();
		}

		$this->assignRef('zoom'   , $zoom);
		$this->assignRef('images'   , $images);
		$this->assignRef('galleries'   , $galleries);
		$this->assignRef('gallery'   , $gallery);
		$this->assignRef('params'   , $params);
		$this->assignRef('access'   , $access);
		$this->assignRef('pagination',	$pagination);

		parent::display($tpl);
	}

	function _editForm(&$gallery,$tpl) {
		global $mainframe,$zoom;

		$params	=& $mainframe->getParams('com_zoom');
		$user	=& JFactory::getUser();
		$uri	=& JFactory::getURI();

		$this->assignRef('zoom',	$zoom);
		$this->assignRef('action',	$uri->toString());
		$this->assignRef('gallery',	$gallery);
		$this->assignRef('params',	$params);
		$this->assignRef('user',	$user);

		parent::display($tpl);
	}

	function _organizeForm(&$gallery,$tpl) {
		global $mainframe,$zoom;

		$params		=& $mainframe->getParams('com_zoom');
		$user		=& JFactory::getUser();
		$uri		=& JFactory::getURI();
		$images		=& $this->get('Images');
		$subgalleries	=& $this->get('Subgalleries');

		$this->assignRef('zoom',	$zoom);
		$this->assignRef('action',	$uri->toString());
		$this->assignRef('gallery',	$gallery);
		$this->assignRef('subgalleries',$subgalleries);
		$this->assignRef('images',	$images);
		$this->assignRef('params',	$params);
		$this->assignRef('user',	$user);

		parent::display($tpl);
	}

	function _deleteForm(&$gallery,$tpl) {
		global $mainframe,$zoom;

		$params		=& $mainframe->getParams('com_zoom');
		$user		=& JFactory::getUser();
		$uri		=& JFactory::getURI();

		$this->assignRef('zoom',	$zoom);
		$this->assignRef('action',	$uri->toString());
		$this->assignRef('gallery',	$gallery);
		$this->assignRef('params',	$params);
		$this->assignRef('user',	$user);

		parent::display($tpl);
	}

	function _uploadForm(&$gallery,$tpl) {
		global $mainframe,$zoom;

		$params		=& $mainframe->getParams('com_zoom');
		$user		=& JFactory::getUser();
		$uri		=& JFactory::getURI();
		$step		=  JRequest::getInt('step',1);

		if ($step <= 1) {
			if ( $zoom->_CONFIG['uplflash'] ) {
				JHTML::_('behavior.uploader', 'file-upload', array());
			}
		} else {
			if ( isset($_SESSION['zmg_upl_files']) ) {
				$files = array();
				foreach ($_SESSION['zmg_upl_files'] as $id) {
					$img = new image($id);
					$img->getInfo();
					$files[] = $img;
				}
				$this->assignRef('files',	$files);
			}
			$tpl = 'upload2';
		}

		$this->assignRef('session', JFactory::getSession());
		$this->assignRef('zoom',	$zoom);
		$this->assignRef('action',	$uri->toString());
		$this->assignRef('gallery',	$gallery);
		$this->assignRef('params',	$params);
		$this->assignRef('user',	$user);


		parent::display($tpl);
	}

	function showMediaRSS(&$gallery,&$images) {

		$this->assignRef('gallery'   , $gallery);
		$this->assignRef('images'   , $images);

		header('Content-type: text/xml; charset=UTF-8');
		parent::display('mediarss');
		exit;
	}
}
