<?php

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once (JPATH_COMPONENT.DS.'view.php');

/**
 * HTML Zoom View class for the ZMG component
 *
 * @package	     zOOmGallery
 * @subpackage  zOOmGallery
 * @since 1.5
 */
class ZoomViewMedia extends ZoomView
{

	function  display($tpl = null)
	{
		global $zoom,$mainframe;

		$key = intval($zoom->getParam($_REQUEST, 'key'));
		$PageNo = intval($zoom->getParam($_REQUEST, 'PageNo'));
		$task = $zoom->getParam($_REQUEST, 'task');

		$gallery =& $zoom->_gallery;
		$image 	 =& $gallery->_images[$key];
		$params	 =& $mainframe->getParams('com_zoom');
		$pathway =& $mainframe->getPathway();

		$image->getInfo();

		if ( $task == 'download' ) {
			$this->sendFile($image,$gallery);
		}

		$medium_name = (empty($image->_name)) ? $image->_filename : $image->_name;
		$pathway->addItem($gallery->_name, ZoomHelperRoute::getGalleryRoute($gallery->_slug). '&PageNo='.$PageNo );
		$pathway->addItem($medium_name);

		if($this->getLayout() == 'form') {
			$this->_displayForm($gallery,$image,$tpl);
			return;
		}

		$document =& JFactory::getDocument();
		$document->setTitle($zoom->revnumericentities($image->_name . ' - ' . $gallery->_name));

		// Array with the ids for first, prev, next and last images of the gallery
		$neighbours = $this->getMediaNeighbours($gallery,$image);

		$this->assignRef('zoom'    , $zoom);
		$this->assignRef('neighbours'   , $neighbours);
		$this->assignRef('image'   , $image);
		$this->assignRef('gallery' , $gallery);
		$this->assignRef('params'  , $params);

		parent::display($tpl);
	}

	function _displayForm($gallery,$image,$tpl) {
		global $mainframe,$zoom;

		$params	=& $mainframe->getParams('com_zoom');
		$user	=& JFactory::getUser();

		$this->assignRef('zoom',	$zoom);
		$this->assignRef('gallery',	$gallery);
		$this->assignRef('image',	$image);
		$this->assignRef('params',	$params);
		$this->assignRef('user',	$user); 

		$zoom->createProgressScript('search');
		$zoom->hideProgress();
		parent::display($tpl);
	}

	function sendFile (&$media,&$gallery) {
		global $zoom;

		$type  = JRequest::getInt('type');
		$nohit = JRequest::getInt('nohit');
		$crop  = JRequest::getVar('crop','');

		if ($crop === '') {
			$crop  = $zoom->_CONFIG['cropthumbs'];
		}

		$mimetype = $media->getMimeType();
		if ($type == 0) { //Viewsize
			$file = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$gallery->_dir.DS.$media->_viewsize;
		} elseif ($type == 1) { //Fullsize
			$file = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$gallery->_dir.DS.$media->_filename;
		} elseif ($type == 2) { //Thumbnail
			$live_site = substr_replace(JURI::root(), "", -1, 1);
			$file = $media->_thumbnail;
			$file = str_replace($live_site, JPATH_SITE, $file);
			if ($crop === '1' && $zoom->isImage($media->_type)){
				$file = JFile::stripExt($file).'_crop.'.JFile::getExt($file);
			}
			if (!$zoom->platform->file_exists($file)) {
				$srcfile = JPATH_SITE.DS.$zoom->_CONFIG['imagepath'].$gallery->_dir.DS.$media->_filename;
				$media->_size = $zoom->platform->getimagesize($srcfile);
				$zoom->toolbox->resizeImage($srcfile, $file, $zoom->_CONFIG['size'], $this,($crop==='1'));
			}
			$img_type = $media->_thumbtype;
		}
		$file = str_replace(' ','%20',$file); 

		if ( function_exists('apache_request_headers') ) {
			// Getting headers sent by the client.
			$headers = apache_request_headers();
		} else {
			$headers = array();
		}

		$filetime = filemtime($file);
		// Checking if the client is validating his cache and if it is current.
		if (isset($headers['If-Modified-Since']) && (strtotime($headers['If-Modified-Since']) == $filetime)) {
			// Client's cache IS current, so we just respond '304 Not Modified'.
			header('Last-Modified: '.gmdate('D, d M Y H:i:s', $filetime).' GMT', true, 304);
		} else {
			// Count the hit only if this is the viewsize or is not an image
			// and this media havent't been counted already on this session
			if ( !isset($_SESSION['zmghits'][$media->_id]) && (!$zoom->isImage($media->_type) || $type == 0) && !$nohit ) {
				$media->hitPlus();
				$_SESSION['zmghits'][$media->_id] = true;
			}
			// Image not cached or cache outdated, we respond '200 OK' and output the image.
			header('Last-Modified: '.gmdate('D, d M Y H:i:s', $filetime).' GMT', true, 200);
			header('Content-Length: '.filesize($file));
			header('Content-Type:' . $mimetype);
			header('Cache-Control: private'); 
			header("Pragma: private");
			header('Expires: ' . gmdate('D, d M Y H:i:s', time()+(24*60*60*5)) . ' GMT');
			header('Content-Disposition: inline; filename=' . basename($file));
			@readfile($file);
			exit;
		}
	}
	
	/*
	 * Return an array with the ids for first, prev, next and last images of the gallery
	 *
	*/
	function getMediaNeighbours (&$gallery, &$media) {

		$keys = array_keys($gallery->_images);
		$i=0;
		$continue = true;
		while($continue) {
			$gallery->_images[$keys[$i]]->getInfo(false);
			if($gallery->_images[$keys[$i]]->isMember()) {
				$first_img = $keys[$i];
				$continue = false;
			} else {
				$i++;
			}
		}

		$i=count($gallery->_images)-1;
		$continue = true;
		while($continue) {
		$gallery->_images[$keys[$i]]->getInfo(false);
		if($gallery->_images[$keys[$i]]->isMember()) {
				$last_img = $keys[$i];
				$continue = false;
			} else {
				$i--;
			}
		}

		if ($media->_id  == $first_img) {
			$pid = $last_img;
		} else {
			if ($media->_id  == $last_img) {
				if($media->_id  == $keys[count($gallery->_images)-1]) {
					$i=array_search($media->_id,$keys)-1;
					$continue = true;
					while($continue && $i >= 0) {
					    $gallery->_images[$keys[$i]]->getInfo(false);
					    if($gallery->_images[$keys[$i]]->isMember()) {
							$pid = $keys[$i];
							$continue = false;
						} else {
							$i--;
						}
					}
				} else {
					$i=array_search($media->_id ,$keys)-1;
					$continue = true;
					while($continue) {
					    $gallery->_images[$keys[$i]]->getInfo(false);
					    if($gallery->_images[$keys[$i]]->isMember()) {
							$pid = $keys[$i];
							$continue = false;
						} else {
							$i--;
						}
					}
				}
			} else {/* I don't know what is this for!!! - GV
				if ($media->_id  == $keys[count($gallery->_images)-2]) {
					$i=array_search($media->_id ,$keys);
					$continue = true;
					while($continue) {
					    $gallery->_images[$keys[$i]]->getInfo(false);
					    if($gallery->_images[$keys[$i]]->isMember()) {
							$pid = $keys[$i];
							$continue = false;
						} else {
							$i--;
						}
					}
				} else {*/
					$i=array_search($media->_id ,$keys)-1;
					$continue = true;
					while( $continue ) {
					    $gallery->_images[$keys[$i]]->getInfo(false);
					    if($gallery->_images[$keys[$i]]->isMember()) {
							$pid = $keys[$i];
							$continue = false;
						} else {
							$i--;
						}
					}
				/* }*/ 
			}
		}
	
		if ($media->_id  == $last_img) {
			$nid = $first_img;
		} else {
			$i=array_search($media->_id ,$keys);
			if($i == (count($gallery->_images) - 1)) {
				die ("No s? qu? hace aqu?!!");
				$continue = true;
				while( $continue ) {
					$gallery->_images[$keys[$i]]->getInfo(false);
					if ($gallery->_images[$keys[$i]]->isMember()) {
						$nid = $keys[$i];
						$continue = false;
					} else {
						$i++;
					}
				}
			} else {
				if ( ($i=array_search($media->_id ,$keys)) !== FALSE ) {
					$i++;
					$continue = true;
					while($continue) {
						$gallery->_images[$keys[$i]]->getInfo(false);
						if($gallery->_images[$keys[$i]]->isMember()) {
								$nid = $keys[$i];
								$continue = false;
						} else {
								$i++;
						}
					}
				}
				if ( !isset($nid) ) {
					$nid = $first_img;
				}
			}
		}
		
		return array(
			'first' => $first_img,
			'prev' => $pid,
			'next' => $nid,
			'last' => $last_img
		);
	}
}
